﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace telek
{
    class Telek
    {
        public int No { get; set; }
        public int Width { get; set; }
        public int Length { get; set; }
        public int Pos { get; set; } //utca elejétől mért távolság
        public int Area()
        {
            return Width * Length;
        }
        public int Tax()
        {
            int alap;
            if (Area() <= 700)
            {
                alap = Area() * 51;
            }
            else if(Area() <= 1000)
            {
                alap = 700 * 51 + (Area() - 700) * 39;
            }
            else
            {
                alap = 700 * 51 + 300 * 39 + 200;
            }
            double szorzó = (Width <= 15 || Length <= 25) ? 0.8 : 1;
            
            return (int)Math.Round(alap * szorzó / 100, 0) * 100;
        }
        public Telek(string[] sor)
        {
            No = int.Parse(sor[0]);
            Width = int.Parse(sor[1]);
            Length = int.Parse(sor[2]);
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            #region 1. feladat beolvasás
            StreamReader sr = new StreamReader("telkek.txt");
            int n = int.Parse(sr.ReadLine());
            int sordb = n / 2;
            Telek[] gazdag = new Telek[sordb + 1];
            Telek[] jólét = new Telek[sordb + 1];
            string[] sor;
            for (int i = 0; i < n; i++)
            {
                sor = sr.ReadLine().Split(' ');
                if (sor[2] == "0")
                {
                    jólét[int.Parse(sor[0]) / 2] = new Telek(sor);
                }
                else
                {
                    gazdag[int.Parse(sor[0]) / 2 + 1] = new Telek(sor);
                }
                
            }
            sr.Close();
            #endregion
            #region 2. feladat körbejárás hossza
            Console.WriteLine("2. feladat");
            int ghossz = 0;
            int jhossz = 0;
            for (int i = 1; i <= sordb; i++)
            {
                gazdag[i].Pos = ghossz;
                ghossz += gazdag[i].Width;
                jólét[i].Pos = jhossz;
                jhossz += jólét[i].Width;
            }
            Console.WriteLine("\t{0} m", Math.Max(ghossz, jhossz) *2 + 160);
            #endregion
            #region 3. feladat front beépítése db
            Console.WriteLine("3. feladat");
            int wdb = 0;
            for (int i = 1; i <= sordb; i++)
            {
                if (jólét[i].Width <=20)
                {
                    wdb++;
                }
            }
            Console.WriteLine("\t{0} db", wdb);
            #endregion
            #region 4. feladat min-max táv Gazdag soron
            Console.WriteLine("4. feladat");
            int min = 1;
            int max = 1;
            for (int i = 2; i <= sordb; i++)
            {
                if (gazdag[i].Area() < gazdag[min].Area())
                {
                    min = i;
                }
                if (gazdag[i].Area() > gazdag[max].Area())
                {
                    max = i;
                }
            }
            if (min == max)     //ez valósznűleg nem kell
            {
                Console.WriteLine("\tminden telek egyforma méretű.");
            }
            else
            {
                Console.WriteLine("\t{0} db telek van közöttük", Math.Abs(min-max) - 1);
                Console.WriteLine("\tA legnagyobb telek házszáma: {0}, területe: {1} nm", gazdag[max].No, gazdag[max].Area());
                Console.WriteLine("\tA legkisebb telek házszáma: {0}, területe: {1} nm", gazdag[min].No, gazdag[min].Area());
            }
            #endregion
            #region 5. feladat adó a Gazdag soron
            Console.WriteLine("5. feladat");
            int össz = 0;
            for (int i = 1; i <= sordb; i++)
            {
                össz += gazdag[i].Tax();
            }
            Console.WriteLine("\t{0} Fabatka az adóbevétel.", össz);
            #endregion
            #region 6. feladat Jólét sor utolsó 3 háza
            Console.WriteLine("6. feladat");
            for (int i = sordb; i >sordb - 3; i--)
            {
                Console.WriteLine("\t{0}. számú ház kezdete {1} m",jólét[i].No ,jólét[i].Pos);
            }
            #endregion
            #region 7. feladat Jólét sor telekhossz
            StreamWriter sw = new StreamWriter("joletsor.csv");
            int j = 1;
            for (int i = 1; i <= sordb; i++)
            {
                int tulso = gazdag[j].Length;
                while (j <= sordb && gazdag[j].Pos <= jólét[i].Pos+ jólét[i].Width)
                {
                    if (gazdag[j].Length > tulso)
                    {
                        tulso = gazdag[j].Length;
                    }
                    j++;
                }
                j--;
                if (gazdag[j].Pos == jólét[i].Pos+ jólét[i].Width)
                {
                    j--;
                }
                jólét[i].Length = 80 - tulso - 10;
                sw.WriteLine("{0};{1};{2}", jólét[i].No, jólét[i].Width, jólét[i].Length);
            }
            sw.Close();
            Console.WriteLine("A fájlbaírás befejeződött. Nyomjon meg egy billentyűt!");
            #endregion
            Console.ReadKey();
        }
    }
}
